import patchparse
import os
import sys
from string import strip
import time

p = patchparse.PatchSet("./f")

def get_file_list_from_changeset(prefix, changeset):

    res = []
    for l in changeset.split('\n'):
        if not l.startswith('        '):
            continue
        star = l.find('*')
        colon = l.find(':')
        if star > 0 and colon > 0:
            fname = l[star+1:colon].strip()
            if fname:
                res.append(prefix + fname)
    return res

#for fname in os.listdir('./patches'):
#    if not fname.startswith('patchset.'):
#        continue

#    files = map(strip, open('./patches/%s' % fname).readlines())

#    changeset = files[0]
#    csrealfilename = changeset.split('.')[0]
#    cs = open(changeset).read()

def recreate_patchfile(changeset, cs):

    csrealfilename = changeset.split('.')[0]
    fname = '.'.join(changeset.split('.')[1:])
    findcl = csrealfilename.find('ChangeLog')
    prefix = csrealfilename[:findcl]
    patchedfiles = get_file_list_from_changeset(prefix, cs)

    print csrealfilename, fname
    for f in patchedfiles:
        print "\t", f

    csp = p.indices[csrealfilename]
    diff = cs.split('\n')
    diff = map(lambda x: '+%s\n' % x, diff)
    currentdate = time.strftime("%Y-%m-%d")
    diff[0] = "+" + currentdate + diff[0][1+len(currentdate):]
    difflen = len(diff)
    csp.diff = [patchparse.FakeDiffSet(diff, '','', '', 1, 1, 0, difflen)]

    f = open("patches/patch.%s" % fname, 'w')
    f.write(str(csp))
    for fname in patchedfiles:
        f.write(str(p.indices[fname]))
    f.close()

idx2 = 0
for k, v in p.indices.items():
    if k.find('ChangeLog') < 0:
        continue
    idx = 0
    for diff in v.diff:
        br = diff.added.find('https://bugs.webkit.org/show_bug.cgi?id=')
        if br > 0:
            id = diff.added.find('=', br)
            bugnum = diff.added[id+1:id+6]
            fname = '%s.%s.txt' % (k, bugnum)
        else:
            fname = '%s.%d.txt' % (k, idx)
        idx += 1
        idx2 += 1
        recreate_patchfile(fname, diff.added)

